

proc iml;




/* This program computes the linearity test statistic which    */
/* is distributed N(0,1). The input matrix is the matrix OUT   */
/* produced by either program.1 or program.2                   */



/* read data. The data matrix is named out where the first row  */
/* correspond to noncentrality paramters, and the second row    */
/* is the 80% dispersion value                                  */
 



/* create column vector of test statistics */

line=out(|1,|)#0.0;

/* seed pop dispersion value and probability value */

pop=3.0;
x=0.0;

/* set numerator of variance */

up=.8*(1-.8);


/* input the value for p */

p=110;





do i=1 to 6;
    lam=out(|1,i|);

            do until (x>.8005);
     
                   pop=pop+.01;
                   x=probchi(pop,2,lam);


           end;



     down=(1-probchi( out(|2,i|), 2 , out(|1,i|) )   )*p;

     sig=up/down;

      line(|1,i|)=abs(  (out(|2,i|)-pop) / sqrt(sig)  );

end;



/* print test statistics */

print line;
